# fluctuation test for constant correlation against single break
# margins are assumed to follow a GARCH process and tested for constant unconditional variance against single break
fluct_GARCH_GaussJoint=function(matX,B=200){
  m = ncol(matX)
  n = nrow(matX)
  matZ=matrix(nrow=n,ncol=m)
  lambda_marg = vector(l=m)
  Qmax_marg = vector(l=m)
  sigma0 = vector(l=m)
  omega0 = vector(l=m)
  for(i in c(1:m)){
    sigma0[i] = mean(matX[,i]^2)
    # Andrews-HAC-estimator 
    y = mle_Gaussian_scores(matX[,i],sigma0[i])
    lmfit = lm(y ~ 1)
    omega0[i] = kernHAC(lmfit,prewhite=FALSE,approx="ARMA(1,1)",sandwich=FALSE)
    param = fluct_Squares(matX[,i],omega0[i])
    Qmax_marg[i] = param$Qmax
    lambda_marg[i] = param$lambda
    if(Qmax_marg[i] > 1.3581){
      vecX1 = matX[c(1:lambda_marg[i]),i]
      vecX2 = matX[c((lambda_marg[i]+1):n),i]
      mle_garch1 = invisible(garch(vecX1,trace=FALSE))
      sigma_bar1=mle_garch1$coef[1]/(1-mle_garch1$coef[2]-mle_garch1$coef[3])
      mle_garch2 = invisible(garch(vecX2,trace=FALSE))
      sigma_bar2=mle_garch2$coef[1]/(1-mle_garch2$coef[2]-mle_garch2$coef[3])
      matZ[c(1:lambda_marg[i]),i]=c(vecX1[1]/sigma_bar1^0.5,mle_garch1$residuals[-1])
      matZ[c((lambda_marg[i]+1):n),i]=c(vecX2[1]/sigma_bar2^0.5,mle_garch2$residuals[-1])
    }
    else{ 
      vecX = matX[,i]
      mle_garch=invisible(garch(vecX,trace=FALSE))
      sigma_bar=mle_garch$coef[1]/(1-mle_garch$coef[2]-mle_garch$coef[3])
      matZ[,i]=c(vecX[1]/sigma_bar^0.5,mle_garch$residuals[-1])
    }
  }
  res=fluct_GaussJoint_wildboot(matZ[,],B=B)
  pval_boot=res$pval_boot
  Qmax=res$Qmax
  lambda=res$lambda
  rho0=res$rho0
  rho1=res$rho1
  rho2=res$rho2
  return(list(pval_boot=pval_boot,Qmax=Qmax,lambda=lambda,Qmax_marg=Qmax_marg,omega0=omega0,lambda_marg=lambda_marg,rho0=rho0,rho1=rho1,rho2=rho2))
}