# sup-lr test for constant t-copula with GARCH-margins
suplr_GARCH_tCopula=function(matX,B){
  m = ncol(matX)
  n = nrow(matX)
  matZ=matrix(nrow=n,ncol=m)
  lambda_marg = vector(l=m)
  suplr_marg = vector(l=m)
  rej_marg = vector(l=m)
  sigma0 = vector(l=m)
  omega0 = vector(l=m)
  # testing at the margins
  for(i in c(1:m)){
    param = suplr_Squares(matX[,i])
    sigma0[i] = param$sigma0
    # Andrews-HAC-estimator 
    y = mle_Gaussian_scores(matX[,i],sigma0[i])
    lmfit = lm(y ~ 1)
    omega0[i] = kernHAC(lmfit,prewhite=FALSE,approx="ARMA(1,1)",sandwich=FALSE)
    cval = supBesselProcess095(omega0[i])
    suplr_marg[i] = param$suplr
    rej_marg[i] = suplr_marg[i] > cval
    lambda_marg[i] = param$lambda
    if(suplr_marg[i] > cval){
      vecX1 = matX[1:lambda_marg[i],i]
      vecX2 = matX[(lambda_marg[i]+1):n,i]
      mle_garch1 = invisible(garch(vecX1,trace=FALSE))
      sigma_bar1=mle_garch1$coef[1]/(1-mle_garch1$coef[2]-mle_garch1$coef[3])
      mle_garch2 = invisible(garch(vecX2,trace=FALSE))
      sigma_bar2=mle_garch2$coef[1]/(1-mle_garch2$coef[2]-mle_garch2$coef[3])
      matZ[c(1:lambda_marg[i]),i]=c(vecX1[1]/sigma_bar1^0.5,mle_garch1$residuals[-1])
      matZ[c((lambda_marg[i]+1):n),i]=c(vecX2[1]/sigma_bar2^0.5,mle_garch2$residuals[-1])
    }
    else{ 
      vecX = matX[,i]
      mle_garch =invisible(garch(vecX,trace=FALSE))
      sigma_bar=mle_garch$coef[1]/(1-mle_garch$coef[2]-mle_garch$coef[3])
      matZ[,i]=c(vecX[1]/sigma_bar^0.5,mle_garch$residuals[-1])
    }
  }
  # sup-lr-test
  res=suplr_tCopula_resboot(matZ,B)
  pval_boot=res$pval_boot
  suplr=res$suplr
  lambda=res$lambda
  nu=res$nu
  rho0=res$rho0
  rho1=res$rho1
  rho2=res$rho2
  return(list(pval_boot=pval_boot,suplr=suplr,lambda=lambda,suplr_marg=suplr_marg,rej_marg=rej_marg,omega0=omega0,lambda_marg=lambda_marg,nu=nu,rho0=rho0,rho1=rho1,rho2=rho2))
}